@rem======================================================================
@rem
@rem    setup.bat
@rem
@rem======================================================================

@echo off
setlocal
pushd .

goto LInitialize


@rem----------------------------------------------------------------------
@rem    LInitialize
@rem----------------------------------------------------------------------
:LInitialize
    set SPAdminTool=%CommonProgramFiles%\Microsoft Shared\web server extensions\12\BIN\stsadm.exe
    set Task=install
    set PackageFile=%~dp0HowManyLists.wsp
    set PackageName=HowManyLists.wsp
    set TargetUrl=http://mossspsdev:500

    goto LParseArgs


@rem----------------------------------------------------------------------
@rem    LParseArgs
@rem----------------------------------------------------------------------
:LParseArgs
    @rem --- help ---
    if "%1" == "/?" goto LHelp
    if "%1" == "-?" goto LHelp
    if "%1" == "/h" goto LHelp
    if "%1" == "-h" goto LHelp
    if "%1" == "/help" goto LHelp
    if "%1" == "-help" goto LHelp

    @rem --- Fix execute task ---
    if "%1" == "/i"         (set Task=install)   & shift & goto LParseArgs
    if "%1" == "-i"         (set Task=install)   & shift & goto LParseArgs
    if "%1" == "/install"   (set Task=install)   & shift & goto LParseArgs
    if "%1" == "-install"   (set Task=install)   & shift & goto LParseArgs
    if "%1" == "/u"         (set Task=uninstall) & shift & goto LParseArgs
    if "%1" == "-u"         (set Task=uninstall) & shift & goto LParseArgs
    if "%1" == "/uninstall" (set Task=uninstall) & shift & goto LParseArgs
    if "%1" == "-uninstall" (set Task=uninstall) & shift & goto LParseArgs
    
    @rem --- Fix url ---
    if "%1" == "/url" (set TargetUrl=%2) & shift & goto LParseArgs
    if "%1" == "-url" (set TargetUrl=%2) & shift & goto LParseArgs

	goto LMain


@rem----------------------------------------------------------------------
@rem	LHelp
@rem----------------------------------------------------------------------
:LHelp
    echo Usage:
    echo setup.bat [/install][/uninstall][url]
    echo           [/help]
    echo.
    echo Options:
    echo  /install
    echo  Install specified Solution package (.wsp) to the SharePoint server.
    echo  /uninstall
    echo  Uninstall specified Solution from the SharePoint server.
    echo  /url
    echo  Specify a url of a site of the SharePoint server.
    echo  Default value: %TargetUrl%
    echo  /help
    echo  Show this information.
    echo.

	goto LTerminate


@rem----------------------------------------------------------------------
@rem    LMain
@rem----------------------------------------------------------------------
:LMain
	if %Task% == install   (call :LDeploy)
	if %Task% == uninstall (call :LRetract)

	goto LTerminate


@rem----------------------------------------------------------------------
@rem    LDeploy
@rem----------------------------------------------------------------------
:LDeploy
    echo Adding solution %PackageName% to the SharePoint ...
    "%SPAdminTool%" -o addsolution -filename "%PackageFile%"

    echo Deploying solution %PackageName% ...
    "%SPAdminTool%" -o deploysolution -name "%PackageName%" -local -allowGacDeployment -url %TargetUrl%

    echo Activating feature HowManyLists ...
    "%SPAdminTool%" -o activatefeature -id 3c478a67-d437-4e8a-b2eb-2650ad26088b -url %TargetUrl%

    goto :EOF


@rem----------------------------------------------------------------------
@rem    LRetract
@rem----------------------------------------------------------------------
:LRetract
    echo Deactivating feature HowManyLists ...
    "%SPAdminTool%" -o deactivatefeature -id 3c478a67-d437-4e8a-b2eb-2650ad26088b -url %TargetUrl%

    echo Uninstalling feature HowManyLists ...
    "%SPAdminTool%" -o uninstallfeature -id 3c478a67-d437-4e8a-b2eb-2650ad26088b -force

    echo Retracting solution %PackageName% ...
    "%SPAdminTool%" -o retractsolution -name "%PackageName%" -local -url %TargetUrl%

    echo Deleting solution %PackageName% from SharePoint ...
    "%SPAdminTool%" -o deletesolution -name "%PackageName%"

    goto :EOF


@rem----------------------------------------------------------------------
@rem    LTerminate
@rem----------------------------------------------------------------------
:LTerminate
    set UserInput=
    set /P UserInput=Hit enter key to quit.

    set SPAdminTool=
    set Task=
    set PackageFile=
    set PackageName=
    set TargetUrl=
    set UserInput=


popd
endlocal

